{-----------------------------------------------------------------------------
Software is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied.

The Original Code is: JvDB.PAS, released on 2011/06/22.

The Initial Developer of the Original Code is: Stephen Mageiras
Copyright (c) 2011 Stephen Mageiras
Copyright (c) 2011 Argonet Software - Greece.

http://www.argonet.gr

-----------------------------------------------------------------------------

INFO:
	GotoBookmark method can now use parameters for full control of Resync behavior.

-	GotoBookmark(BM);
- GotoBookmark(BM, []);
- GotoBookmark(BM, [rmExact, rmCenter]);

-----------------------------------------------------------------------------
TESTING DATABASES FOR ALL PROJECTS:
- PostgreSQL 9.0.4
- Microsoft SQL Server 2008 R2

-----------------------------------------------------------------------------
2011/06/22 - Contributed to jvcl.delphi-jedi.org.
-----------------------------------------------------------------------------}

unit JvDB;

interface

uses
	Classes, DB;

type

	{ TJvDataSet }

	TJvDataSet = class(TDataSet)
	private

	protected

	public
		constructor Create(AOwner: TComponent); override;
		destructor Destroy; override;

		procedure GotoBookmark(Bookmark: TBookmark;
			Mode: TResyncMode = [rmExact, rmCenter]);

		property Bookmark: TBookmark read GetBookmark;

	end;

implementation

{ TJvDataSet }

constructor TJvDataSet.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	{ }
end;

destructor TJvDataSet.Destroy;
begin
	{ }
	inherited Destroy;
end;

procedure TJvDataSet.GotoBookmark(Bookmark: TBookmark;
	Mode: TResyncMode = [rmExact, rmCenter]);
begin
	if Bookmark <> nil then
	begin
		CheckBrowseMode;
		if rmCenter in Mode then DoBeforeScroll;
		InternalGotoBookmark(Pointer(Bookmark));
		Resync(Mode);
		if rmCenter in Mode then DoAfterScroll;
	end;
end;

end.

